import { Subject } from "rxjs";

export var subscribeLinkData = new Subject<yamcsReply>();

 export interface SubscribeLinksRequest {

  // Yamcs instance name.
  instance: string;
}
export interface yamcsReply{
  
    type: string;
    call: number;
    seq: number;
    data: LinkEvent;
}
  

export interface LinkEvent {
    // Type of event. This field is deprecated: in older versions of Yamcs, link updates
    // were sent one-by-one using one of the types: ``REGISTERED``, ``UNREGISTERED`` or
    // ``UPDATED`` and with the ``linkInfo`` field set to that sepific link.
    //
    // In current versions of Yamcs, users are advised to switch to read the ``links``
    // field instead. This will be published automatically about every second with a
    // snapshot of all links. The type for these batch updates is set to ``UPDATE_ALL``.
    type: Type;
  
    // Deprecated: read ``links`` instead.
    linkInfo: LinkInfo;
  
    // Detail for all links.
    links: LinkInfo[];
  }

  export interface LinkInfo {

    // Yamcs instance name.
    instance: string;
  
    // Link name.
    name: string;
  
    // Java class name
    type: string;
  
    // Configuration
    spec: string;
  
    // Whether this link is currently disabled.
    disabled: boolean;
    status: string;
  
    // Counter of inbound (received) data.
    // The unit of this is specific to each link.
    dataInCount: string;  // String decimal
  
    // Counter of outbound (transmitted) data.
    // The unit of this is specific to each link.
    dataOutCount: string;  // String decimal
  
    // Short status information
    detailedStatus: string;
  
    //if this is a sublink of an aggregated data link, this is the name of the parent
    parentName: string;
  
    // Custom actions
    actions: LinkActionInfo[];
  
    // Custom info fields
    extra: {[key: string]: any};
  
    // System parameters generated by this link
    parameters: string[];
  }
  
  export interface LinkActionInfo {
  
    // Action ID.
    id: string;
  
    // Label describing an action
    label: string;
    style: string;
  
    // Whether this action is currently enabled.
    enabled: boolean;
  
    // Whether this action is currently checked.
    checked: boolean;
  }
  
 export enum Type {
  
    // A new link was registered. You also receive this event directly after you subscribe,
    //  for every link that is registered at that time.
    REGISTERED = "REGISTERED",
  
    // A link was unregistered.
    UNREGISTERED = "UNREGISTERED",
  
    // A link was updated in one of its attributes, for example the dataCount has increased,
    // or the status has changed.
    UPDATED = "UPDATED",
  
    // Replace entire model with the link information
    // provided in the `links` field.
    UPDATE_ALL = "UPDATE_ALL",
  }
